import javax.swing.*;
public class TBackgroundPanel extends JPanel {
  private Thread fThread;
  private Object fLock;
  private boolean fNeedsToStop = false;
  private JProgressBar fProgressBar;
  private JButton fStartButton;
  private JButton fStopButton;

  public TBackgroundPanel() {
    fLock = new Object();
    setLayout(new java.awt.BorderLayout());
    add(new JLabel("Status"), java.awt.BorderLayout.NORTH);
    fProgressBar = new JProgressBar();
    add(fProgressBar, java.awt.BorderLayout.CENTER);
    JPanel theButtons = new JPanel();

    fStartButton = new JButton("Start");
    fStartButton.setBackground(java.awt.SystemColor.control);
    theButtons.add(fStartButton);
    fStartButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent e) {
        startTheThread();
      }
    });
    fStopButton = new JButton("Stop");
    fStopButton.setBackground(java.awt.SystemColor.control);
    theButtons.add(fStopButton);
    fStopButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent e) {
        stopTheThread();
      }
    });
    add(theButtons, java.awt.BorderLayout.SOUTH);
  }

  public void startTheThread() {
    if (fThread == null)
      fThread = new TBackgroundThread();
    if (!fThread.isAlive())
    {
      fNeedsToStop = false;
      fThread.start();
    }
  }

  public void stopTheThread() {
    synchronized(fLock) {
      fNeedsToStop = true;
      fLock.notify();
    }
  }

  // inner class, so it has access to private members of panel
  class TBackgroundThread extends Thread {
    public void run() {
      // run at a low priority; after all, we _
      // are_ a background thread
      Thread.currentThread().setPriority(Thread.MIN_PRIORITY);
      int theMinimum = 0;
      int theMaximum = 100;
      fProgressBar.setValue(theMinimum);
      fProgressBar.setMinimum(theMinimum);
      fProgressBar.setMaximum(theMaximum);
      for (int i=0; i<theMaximum; i++) {
        fProgressBar.setValue(i);

        // do the real work of the background thread
        // here

        synchronized(fLock) {
          if (fNeedsToStop)
            break;
          try {
            fLock.wait(100);
          } catch (InterruptedException e) {
            // ignore the exception
          }
        }
      }
      // clue the garbage collector that we're done with the thread
      fThread = null;
    }
  }
}
